# encoding: utf-8

class Bulletin
  include Mongoid::Document
  include Mongoid::Timestamps
  include Mongoid::MultiParameterAttributes
  
  has_one :title, :class_name => "I18nVariable", :as => :language_value, :autosave => true, :dependent => :destroy
  has_one :subtitle, :class_name => "I18nVariable", :as => :language_value, :autosave => true, :dependent => :destroy
  has_one :text, :class_name => "I18nVariable", :as => :language_value, :autosave => true, :dependent => :destroy
  has_and_belongs_to_many :tags, :class_name => "AnnouncementTag"

  field :postdate , :type => Date
  field :deadline , :type => Date
  # field :url
  field :create_user_id
  field :update_user_id
  
  field :is_top, :type => Boolean, :default => false
  field :is_hot, :type => Boolean, :default => false
  field :is_hidden, :type => Boolean, :default => false
  
  field :public, :type => Boolean, :default => true
  
  mount_uploader :image, ImageUploader
  
  belongs_to :bulletin_category
  
  embeds_many :bulletin_links, :cascade_callbacks => true
  embeds_many :bulletin_files, :cascade_callbacks => true

  # has_many :bulletin_files, :autosave => true, :dependent => :destroy
  
  accepts_nested_attributes_for :bulletin_files, :allow_destroy => true
  accepts_nested_attributes_for :bulletin_links, :allow_destroy => true
  
  validates_presence_of :title
  
  before_save :set_key
  

  def self.search( search = nil, category_id = nil )
  
 if category_id.to_s.size > 0 and search.to_s.size > 0
 
      key = /#{search}/
 
   find(:all, :conditions => {title: key, bulletin_category_id: category_id}).desc( :is_top, :postdate )
    
 elsif category_id.to_s.size > 0 and search.to_s.size < 1
 
   find(:all, :conditions => {bulletin_category_id: category_id}).desc( :is_top, :postdate )
 
 elsif search.to_s.size > 0 and category_id.to_s.size < 1
 
      key = /#{search}/
   
   find(:all, :conditions => {title: key}).desc( :is_top, :postdate )
 else
   
   find(:all).desc( :is_top, :postdate)
   
 end
 
  end


  def self.widget_datas
  
 date_now = Time.now
 
    # find(:all, :conditions => {:postdate => {"$lte" => Date.today}, deadline: nil} ).desc( :is_top, :postdate)
 # where( :postdate.lte => date_now ).where( :deadline => nil ).desc(:is_top, :postdate)
 # any_of({ :title => "test" },{:deadline => nil, :title => "123"})
 any_of( {deadline: nil,:postdate.lte => date_now} , {:deadline.gte => date_now,:postdate.lte => date_now} ).desc( :is_top, :postdate)


  end
 

  def is_top?
    self.is_top
  end
  
  def is_hot?
    self.is_hot
  end
  
  def is_hidden?
    self.is_hidden
  end
  
  
  def title
    @title ||= I18nVariable.first(:conditions => {:key => 'title', :language_value_id => self.id, :language_value_type => self.class}) rescue nil
  end

  def subtitle
    @subtitle ||= I18nVariable.first(:conditions => {:key => 'subtitle', :language_value_id => self.id, :language_value_type => self.class}) rescue nil
  end
  
  def text
    @text ||= I18nVariable.first(:conditions => {:key => 'text', :language_value_id => self.id, :language_value_type => self.class}) rescue nil
  end
  
  protected
  
  def set_key
    if title.new_record?
      title.key = 'title'
    end
    if subtitle.new_record?
      subtitle.key = 'subtitle'
    end
    if text.new_record?
      text.key = 'text'
    end
  end
  
  
end